OSDN Git Service

* gcc.target/i386/recip-vec-divf.c: Decrease array sizes.
[pf3gnuchains/gcc-fork.git] / contrib / gcc_update
1 #! /bin/sh
2 #
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
6 #
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
10 #
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License.  A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 #
15 #
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
20 #
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
23 #
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
27 #
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
30 #
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
33 #
34 # Examples:
35 #
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
40
41
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
44
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
50
51 ######## Anything below shouldn't be changed by regular users.
52
53 # Arrange for the value of $0 to be available for functions
54 self=$0
55
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60     if [ -z "$silent" ]; then
61         echo "$@"
62     fi
63 }
64
65 # This function prints a list of all generated files, along with their
66 # dependencies.  Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69     sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/genopt.sh
84 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
85 # And then, language-specific files
86 gcc/cp/cfns.h: gcc/cp/cfns.gperf
87 gcc/java/keyword.h: gcc/java/keyword.gperf
88 # testsuite
89 # Without this, _Pragma3.c can have a false negative.
90 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
91 # Similarly, without this, you will see:
92 # direct2s.c:35: warning: current file is older than direct2.c
93 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
94 # lto-plugin
95 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
96 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
97 # And libraries, at last
98 libbanshee/configure: libbanshee/configure.ac
99 libmudflap/configure: libmudflap/configure.ac
100 libobjc/configure: libobjc/configure.ac
101 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
102 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
103 zlib/configure: zlib/configure.ac zlib/aclocal.m4
104 fastjar/aclocal.m4: fastjar/configure.ac
105 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
106 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
107 boehm-gc/aclocal.m4: boehm-gc/configure.ac
108 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
109 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
110 libada/configure: libada/configure.ac
111 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
112 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
113 libffi/configure: libffi/configure.ac libffi/aclocal.m4
114 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
115 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
116 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
117 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
118 libjava/aclocal.m4: libjava/configure.ac
119 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
120 libjava/configure: libjava/configure.ac libjava/aclocal.m4
121 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
122 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
123 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
124 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
125 libcpp/aclocal.m4: libcpp/configure.ac
126 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
127 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
128 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
129 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
130 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
131 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
132 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
133 # Top level
134 Makefile.in: Makefile.tpl Makefile.def
135 configure: configure.ac config/acx.m4
136 EOF
137 }
138
139
140 # This function touches generated files such that the ``end'' user does
141 # not have to rebuild them.
142 touch_files () {
143     rm -f Makefile.$$
144     echo 'all: \' > Makefile.$$
145     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
146     echo '; @true' >> Makefile.$$
147     files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
148     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
149     echo ':' >> Makefile.$$
150     echo '      @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
151     echo '      echo Touching $@...; \' >> Makefile.$$
152     chat '      echo Touching $@... 1>&2; \' >> Makefile.$$
153     echo '      touch $@' >> Makefile.$$
154     files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
155
156     # We would have to explicitly shut off the "Entering... Leaving..."
157     # messages through "--no-print-directory" to handle the case when
158     # we were called from a recursive invocation (i.e. "$(MAKE)" in a
159     # Makefile, not just make).  Passing only "-s" doesn't help then,
160     # because make has helpfully added "-w" to MAKEFLAGS automatically.
161     # Unfortunately we do not require GNU make other than for building
162     # and testing, so let's just grep known text explicitly echoed by
163     # the rule.
164     while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
165       sleep 1
166     done 2>&1
167     rm -f Makefile.$$
168 }
169
170
171 # Whenever we update the tree or install a patch, we may be modifying
172 # this script.  By re-execing it, we ensure that the appropriate
173 # dependencies and rules will be used.
174 touch_files_reexec () {
175     chat "Adjusting file timestamps"
176     exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
177 }
178
179 # This functions applies a patch to an existing tree.
180 apply_patch () {
181     if [ -f "$1" ]; then
182         echo "Applying patch file $1"
183         case $1 in
184         *gz)
185             gzip -d -c "$1" | patch -p1 ;;
186         *bz2)
187             bzip2 -d -c "$1" | patch -p1 ;;
188         *)
189             patch -p1 < "$1";;
190         esac
191     fi
192     touch_files_reexec
193 }
194
195 # Check whether this indeed looks like a local tree.
196 if [ ! -f gcc/version.c ]; then
197     echo "This does not seem to be a GCC tree!"
198     exit
199 fi
200
201 case "$1" in
202 --silent)
203     silent=t
204     shift
205     ;;
206 esac
207
208 case "$1" in
209 # First of all, check whether we are going to process a patch.
210 --patch)
211     if test "$#" != 2; then
212         echo "$1" expects only one argument >&2
213         exit 1
214     fi
215     apply_patch "${2}"
216     exit $?
217     ;;
218
219 --touch)
220     if test "$#" != 1; then
221         echo "$1" does not expect any argument >&2
222         exit 1
223     fi
224     touch_files
225     exit $?
226     ;;
227
228 --list)
229     if test "$#" != 1; then
230         echo "$1" does not expect any argument >&2
231         exit 1
232     fi
233     files_and_dependencies | sed 's/ /: /'
234     exit $?
235     ;;
236
237 --help)
238     sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
239 \
240
241 p
242 }' \
243         -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
244     exit $?
245     ;;
246
247 esac
248
249 # Check for known version control systems.
250 if [ -d .git ]; then
251     GCC_GIT=${GCC_GIT-${GIT-git}}
252     vcs_type="git"
253 elif [ -d .hg ]; then
254     GCC_HG=${GCC_HG-${HG-hg}}
255     vcs_type="hg"
256 elif [ -d .svn ]; then
257     GCC_SVN=${GCC_SVN-${SVN-svn}}
258     vcs_type="svn"
259 else
260     echo "This does not seem to be a GCC GIT/HG/SVN tree!"
261     exit
262 fi
263
264 # Check command-line options
265 if [ x"${1}"x = x"--nostdflags"x ]; then
266     shift
267 else
268     set -- $UPDATE_OPTIONS ${1+"$@"}
269 fi
270
271 case $vcs_type in
272     git)
273         chat "Updating GIT tree"
274
275         $GCC_GIT diff --quiet --exit-code HEAD
276         if [ $? -ne 0 ]; then
277             echo "Attempting to update a dirty git tree!" >&2
278             echo "Commit or stash your changes first and retry." >&2
279             exit 1
280         fi
281
282         $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
283         if [ $? -ne 0 ]; then
284             (touch_files_reexec)
285             echo "git pull of full tree failed." >&2
286             exit 1
287         fi
288
289         revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
290         branch=`$GCC_GIT name-rev --name-only HEAD || :`
291         ;;    
292
293     hg)
294         chat "Updating HG tree"
295
296         # Add -q so untracked files aren't listed.
297         if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
298             echo "Attempting to update a dirty hg tree!" >&2
299             echo "Commit or revert your changes first and retry." >&2
300             exit 1
301         fi
302
303         # Check for mq extension.  mq patches must be popped so tip has
304         # been converted from the SVN tree.
305         if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
306             # FIXME: Perhaps pop queue instead?  We could do that since we
307             # know the tree is clean.
308             echo "Attempting to update hg tree with mq patches applied!" >&2
309             echo "Pop your patches first and retry." >&2
310             exit 1
311         fi
312
313         # Update tree, but make sure to only pull the default branch.
314         # Otherwise all branches in the upstream repo are added, even if
315         # only a single one has been cloned.
316         $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
317         if [ $? -ne 0 ]; then
318             (touch_files_reexec)
319             echo "hg pull of full tree failed." >&2
320             exit 1
321         fi
322
323         # Update tree.  Needs to be done separately from pull so
324         # gcc_update -rREV works.
325         $GCC_HG update ${silent+-q} ${1+"$@"}
326         if [ $? -ne 0 ]; then
327             (touch_files_reexec)
328             echo "hg update of full tree failed." >&2
329             exit 1
330         fi
331
332         # Extract SVN revision corresponding to parents, as stored by
333         # hg convert.  Before hg 1.4.3, there's no template keyword
334         # corresponding to the extra: tag, so need to use hg log --debug
335         # to extract the info.
336         parents=`$GCC_HG parents --template '{rev}'`
337         revision=`$GCC_HG log --debug -r$parents | \
338             sed -ne "/^extra:.*convert_revision=svn:/ {
339                 s%^.*@%%
340                 p
341             }"`
342         branch=`$GCC_HG branch`
343         # trunk in SVN parlance shows up as default branch in hg.
344         [ x$branch = x"default" ] && branch="trunk"
345         ;;
346
347     svn)
348         chat "Updating SVN tree"
349
350         $GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
351         if [ $? -ne 0 ]; then
352             (touch_files_reexec)
353             echo "SVN update of full tree failed." >&2
354             exit 1
355         fi
356
357         revision=`svn info | awk '/Revision:/ { print $2 }'`
358         branch=`svn info | sed -ne "/URL:/ {
359             s,.*/trunk,trunk,
360             s,.*/branches/,,
361             s,.*/tags/,,
362             p
363         }"`
364         ;;
365 esac
366
367 rm -f LAST_UPDATED gcc/REVISION
368 {
369     date
370     echo "`TZ=UTC date` (revision $revision)"
371 } > LAST_UPDATED
372 echo "[$branch revision $revision]" > gcc/REVISION
373
374 touch_files_reexec